import prisma from '../utilities/Prisma'; // Import the global Prisma instance
import { Object } from '@prisma/client'

class ObjectRepository {
    async getById(id: string): Promise<Object | null> {
        return prisma.object.findUnique({
            where: { id },
        });
    }

    async getAll(): Promise<Object[]> {
        return prisma.object.findMany();
    }

    async create(name: string, origin_x: number, origin_y: number): Promise<Object> {
        return prisma.object.create({
            data: {
                name,
                origin_x,
                origin_y
            },
        });
    }

    async update(id: string, name: string, tags: string[], origin_x: number, origin_y: number): Promise<Object> {
        return prisma.object.update({
            where: { id },
            data: {
                name,
                tags,
                origin_x,
                origin_y
            },
        });
    }

    async delete(id: string): Promise<Object> {
        return prisma.object.delete({
            where: { id },
        });
    }
}

export default new ObjectRepository();